package com.nisum.ascend.inventory.service;

import com.nisum.ascend.inventory.dto.ProductDto;
import com.nisum.ascend.inventory.model.Product;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Mono;
import com.nisum.ascend.inventory.repository.ProductRepository;

@Service
public class ProductService {
    @Autowired
    ProductRepository productRepository;

    public Mono<ProductDto> createProduct(Product product) {
        // TODO: Add explicit check for existing SKU
        return productRepository.save(product)
                .map(ProductDto::generateDtoFromProduct)
                .onErrorMap(throwable -> throwable);
    }
}
